Index: IOIPSL/trunk/src/getincom.f90
===================================================================
--- IOIPSL/trunk/src/getincom.f90	(revision 10)
+++ IOIPSL/trunk/src/getincom.f90	(revision 11)
@@ -1,20 +1,21 @@
-!$Header: /home/ioipsl/CVSROOT/IOIPSL/src/getincom.f90,v 2.1 2006/04/05 16:18:43 adm Exp $
+!$Id$
 !-
 MODULE getincom
 !---------------------------------------------------------------------
-  USE stringop, &
- &   ONLY : findpos,nocomma,cmpblank,strlowercase,gensig,find_sig
-!-
-  IMPLICIT NONE
-!-
-  PRIVATE
-  PUBLIC :: getin, getin_dump
-!-
-  INTERFACE getin
-    MODULE PROCEDURE getinrs, getinr1d, getinr2d, &
- &                   getinis, getini1d, getini2d, &
- &                   getincs, getinc1d, getinc2d, &
- &                   getinls, getinl1d, getinl2d
-  END INTERFACE
+USE errioipsl, ONLY : ipslerr
+USE stringop, &
+ &   ONLY : nocomma,cmpblank,strlowercase,gensig,find_sig
+!-
+IMPLICIT NONE
+!-
+PRIVATE
+PUBLIC :: getin, getin_dump
+!-
+INTERFACE getin
+  MODULE PROCEDURE getinrs, getinr1d, getinr2d, &
+ &                 getinis, getini1d, getini2d, &
+ &                 getincs, getinc1d, getinc2d, &
+ &                 getinls, getinl1d, getinl2d
+END INTERFACE
 !-
   INTEGER,PARAMETER :: max_files=100
@@ -22,19 +23,22 @@
   INTEGER,SAVE      :: nbfiles
 !-
-  INTEGER,PARAMETER :: max_lines=500
+  INTEGER,PARAMETER :: max_lines=500,l_n=30
   INTEGER,SAVE :: nb_lines
   CHARACTER(LEN=100),DIMENSION(max_lines),SAVE :: fichier
   INTEGER,DIMENSION(max_lines),SAVE :: targetsiglist,fromfile,compline
-  CHARACTER(LEN=30),DIMENSION(max_lines),SAVE  :: targetlist
+  CHARACTER(LEN=l_n),DIMENSION(max_lines),SAVE  :: targetlist
+!-
+  INTEGER,PARAMETER :: n_d_fmt=5,max_msgs=15
+  CHARACTER(LEN=6),SAVE :: c_i_fmt = '(I5.5)'
 !-
 ! The data base of parameters
 !-
   INTEGER,PARAMETER :: memslabs=200
-  INTEGER,PARAMETER :: compress_lim = 20
+  INTEGER,PARAMETER :: compress_lim=20
 !-
   INTEGER,SAVE :: nb_keys=0
   INTEGER,SAVE :: keymemsize=0
   INTEGER,SAVE,ALLOCATABLE :: keysig(:)
-  CHARACTER(LEN=30),SAVE,ALLOCATABLE :: keystr(:)
+  CHARACTER(LEN=l_n),SAVE,ALLOCATABLE :: keystr(:)
 !-
 ! keystatus definition
@@ -46,9 +50,11 @@
 !-
 ! keytype definition
-! keytype = 1 : Interger
+! keytype = 1 : Integer
 ! keytype = 2 : Real
 ! keytype = 3 : Character
 ! keytype = 4 : Logical
 !-
+  INTEGER,PARAMETER :: k_i=1, k_r=2, k_c=3, k_l=4
+!-
   INTEGER,SAVE,ALLOCATABLE :: keytype(:)
 !-
@@ -63,36 +69,36 @@
   INTEGER,SAVE,ALLOCATABLE :: keymemlen(:)
 !-
-  INTEGER,SAVE,ALLOCATABLE :: intmem(:)
-  INTEGER,SAVE             :: intmemsize=0, intmempos=0
-  REAL,SAVE,ALLOCATABLE :: realmem(:)
-  INTEGER,SAVE          :: realmemsize=0, realmempos=0
-  CHARACTER(LEN=100),SAVE,ALLOCATABLE :: charmem(:)
-  INTEGER,SAVE             :: charmemsize=0, charmempos=0
-  LOGICAL,SAVE,ALLOCATABLE :: logicmem(:)
-  INTEGER,SAVE             :: logicmemsize=0, logicmempos=0
+  INTEGER,SAVE,ALLOCATABLE :: i_mem(:)
+  INTEGER,SAVE             :: i_memsize=0, i_mempos=0
+  REAL,SAVE,ALLOCATABLE :: r_mem(:)
+  INTEGER,SAVE          :: r_memsize=0, r_mempos=0
+  CHARACTER(LEN=100),SAVE,ALLOCATABLE :: c_mem(:)
+  INTEGER,SAVE             :: c_memsize=0, c_mempos=0
+  LOGICAL,SAVE,ALLOCATABLE :: l_mem(:)
+  INTEGER,SAVE             :: l_memsize=0, l_mempos=0
 !-
 CONTAINS
 !-
-!=== REAL INTERFACES
-!-
-SUBROUTINE getinrs (TARGET,ret_val)
-!---------------------------------------------------------------------
-!-  Get a real scalar. We first check if we find it
-!-  in the database and if not we get it from the run.def
-!-
-!-  getinr1d and getinr2d are written on the same pattern
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  REAL :: ret_val
-!-
-  REAL,DIMENSION(1) :: tmp_ret_val
-  INTEGER :: target_sig, pos, status=0, fileorig
+!=== INTEGER INTERFACE
+!-
+SUBROUTINE getinis (target,ret_val)
+!---------------------------------------------------------------------
+!- Get a interer scalar. We first check if we find it
+!- in the database and if not we get it from the run.def
+!-
+!- getini1d and getini2d are written on the same pattern
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: target
+  INTEGER :: ret_val
+!-
+  INTEGER,DIMENSION(1) :: tmp_ret_val
+  INTEGER :: target_sig,pos,status=0,fileorig
 !---------------------------------------------------------------------
 !-
 ! Compute the signature of the target
 !-
-  CALL gensig (TARGET,target_sig)
+  CALL gensig (target,target_sig)
 !-
 ! Do we have this target in our database ?
@@ -104,34 +110,33 @@
   IF (pos < 0) THEN
 !-- Get the information out of the file
-    CALL getfilr (TARGET,status,fileorig,tmp_ret_val)
+    CALL get_fil (target,status,fileorig,i_val=tmp_ret_val)
 !-- Put the data into the database
-    CALL getdbwr (TARGET,target_sig,status,fileorig,1,tmp_ret_val)
+    CALL get_wdb &
+ &   (target,target_sig,status,fileorig,1,i_val=tmp_ret_val)
   ELSE
 !-- Get the value out of the database
-    CALL getdbrr (pos,1,TARGET,tmp_ret_val)
+    CALL get_rdb (pos,1,target,i_val=tmp_ret_val)
   ENDIF
   ret_val = tmp_ret_val(1)
 !---------------------
-END SUBROUTINE getinrs
-!-
+END SUBROUTINE getinis
 !===
-!-
-SUBROUTINE getinr1d (TARGET,ret_val)
-!---------------------------------------------------------------------
-!- See getinrs for details. It is the same thing but for a vector
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  REAL,DIMENSION(:) :: ret_val
-!-
-  REAL,DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
+SUBROUTINE getini1d (target,ret_val)
+!---------------------------------------------------------------------
+!- See getinis for details. It is the same thing but for a vector
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: target
+  INTEGER,DIMENSION(:) :: ret_val
+!-
+  INTEGER,DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
   INTEGER,SAVE :: tmp_ret_size = 0
-  INTEGER :: target_sig, pos, size_of_in, status=0, fileorig
+  INTEGER :: target_sig,pos,size_of_in,status=0,fileorig
 !---------------------------------------------------------------------
 !-
 ! Compute the signature of the target
 !-
-  CALL gensig (TARGET,target_sig)
+  CALL gensig (target,target_sig)
 !-
 ! Do we have this target in our database ?
@@ -150,37 +155,35 @@
 !-
   IF (pos < 0) THEN
-!-- Ge the information out of the file
-    CALL getfilr (TARGET,status,fileorig,tmp_ret_val)
+!-- Get the information out of the file
+    CALL get_fil (target,status,fileorig,i_val=tmp_ret_val)
 !-- Put the data into the database
-    CALL getdbwr &
- &   (TARGET,target_sig,status,fileorig,size_of_in,tmp_ret_val)
+    CALL get_wdb &
+ &   (target,target_sig,status,fileorig,size_of_in,i_val=tmp_ret_val)
   ELSE
 !-- Get the value out of the database
-    CALL getdbrr (pos,size_of_in,TARGET,tmp_ret_val)
+    CALL get_rdb (pos,size_of_in,target,i_val=tmp_ret_val)
   ENDIF
   ret_val(1:size_of_in) = tmp_ret_val(1:size_of_in)
 !----------------------
-END SUBROUTINE getinr1d
-!-
+END SUBROUTINE getini1d
 !===
-!-
-SUBROUTINE getinr2d (TARGET,ret_val)
-!---------------------------------------------------------------------
-!- See getinrs for details. It is the same thing but for a matrix
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  REAL,DIMENSION(:,:) :: ret_val
-!-
-  REAL,DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
+SUBROUTINE getini2d (target,ret_val)
+!---------------------------------------------------------------------
+!- See getinis for details. It is the same thing but for a matrix
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: target
+  INTEGER,DIMENSION(:,:) :: ret_val
+!-
+  INTEGER,DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
   INTEGER,SAVE :: tmp_ret_size = 0
   INTEGER :: target_sig,pos,size_of_in,size_1,size_2,status=0,fileorig
-  INTEGER :: jl, jj, ji
+  INTEGER :: jl,jj,ji
 !---------------------------------------------------------------------
 !-
 ! Compute the signature of the target
 !-
-  CALL gensig (TARGET,target_sig)
+  CALL gensig (target,target_sig)
 !-
 ! Do we have this target in our database ?
@@ -208,12 +211,163 @@
 !-
   IF (pos < 0) THEN
-!-- Ge the information out of the file
-    CALL getfilr (TARGET,status,fileorig,tmp_ret_val)
+!-- Get the information out of the file
+    CALL get_fil (target,status,fileorig,i_val=tmp_ret_val)
 !-- Put the data into the database
-    CALL getdbwr &
- &   (TARGET,target_sig,status,fileorig,size_of_in,tmp_ret_val)
+    CALL get_wdb &
+ &   (target,target_sig,status,fileorig,size_of_in,i_val=tmp_ret_val)
   ELSE
 !-- Get the value out of the database
-    CALL getdbrr (pos,size_of_in,TARGET,tmp_ret_val)
+    CALL get_rdb (pos,size_of_in,target,i_val=tmp_ret_val)
+  ENDIF
+!-
+  jl=0
+  DO jj=1,size_2
+    DO ji=1,size_1
+      jl=jl+1
+      ret_val(ji,jj) = tmp_ret_val(jl)
+    ENDDO
+  ENDDO
+!----------------------
+END SUBROUTINE getini2d
+!-
+!=== REAL INTERFACE
+!-
+SUBROUTINE getinrs (target,ret_val)
+!---------------------------------------------------------------------
+!-  Get a real scalar. We first check if we find it
+!-  in the database and if not we get it from the run.def
+!-
+!-  getinr1d and getinr2d are written on the same pattern
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: target
+  REAL :: ret_val
+!-
+  REAL,DIMENSION(1) :: tmp_ret_val
+  INTEGER :: target_sig,pos,status=0,fileorig
+!---------------------------------------------------------------------
+!-
+! Compute the signature of the target
+!-
+  CALL gensig (target,target_sig)
+!-
+! Do we have this target in our database ?
+!-
+  CALL find_sig (nb_keys,keystr,target,keysig,target_sig,pos)
+!-
+  tmp_ret_val(1) = ret_val
+!-
+  IF (pos < 0) THEN
+!-- Get the information out of the file
+    CALL get_fil (target,status,fileorig,r_val=tmp_ret_val)
+!-- Put the data into the database
+    CALL get_wdb &
+ &   (target,target_sig,status,fileorig,1,r_val=tmp_ret_val)
+  ELSE
+!-- Get the value out of the database
+    CALL get_rdb (pos,1,target,r_val=tmp_ret_val)
+  ENDIF
+  ret_val = tmp_ret_val(1)
+!---------------------
+END SUBROUTINE getinrs
+!===
+SUBROUTINE getinr1d (target,ret_val)
+!---------------------------------------------------------------------
+!- See getinrs for details. It is the same thing but for a vector
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: target
+  REAL,DIMENSION(:) :: ret_val
+!-
+  REAL,DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
+  INTEGER,SAVE :: tmp_ret_size = 0
+  INTEGER :: target_sig,pos,size_of_in,status=0,fileorig
+!---------------------------------------------------------------------
+!-
+! Compute the signature of the target
+!-
+  CALL gensig (target,target_sig)
+!-
+! Do we have this target in our database ?
+!-
+  CALL find_sig (nb_keys,keystr,target,keysig,target_sig,pos)
+!-
+  size_of_in = SIZE(ret_val)
+  IF (.NOT.ALLOCATED(tmp_ret_val)) THEN
+    ALLOCATE (tmp_ret_val(size_of_in))
+  ELSE IF (size_of_in > tmp_ret_size) THEN
+    DEALLOCATE (tmp_ret_val)
+    ALLOCATE (tmp_ret_val(size_of_in))
+    tmp_ret_size = size_of_in
+  ENDIF
+  tmp_ret_val(1:size_of_in) = ret_val(1:size_of_in)
+!-
+  IF (pos < 0) THEN
+!-- Get the information out of the file
+    CALL get_fil (target,status,fileorig,r_val=tmp_ret_val)
+!-- Put the data into the database
+    CALL get_wdb &
+ &   (target,target_sig,status,fileorig,size_of_in,r_val=tmp_ret_val)
+  ELSE
+!-- Get the value out of the database
+    CALL get_rdb (pos,size_of_in,target,r_val=tmp_ret_val)
+  ENDIF
+  ret_val(1:size_of_in) = tmp_ret_val(1:size_of_in)
+!----------------------
+END SUBROUTINE getinr1d
+!===
+SUBROUTINE getinr2d (target,ret_val)
+!---------------------------------------------------------------------
+!- See getinrs for details. It is the same thing but for a matrix
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: target
+  REAL,DIMENSION(:,:) :: ret_val
+!-
+  REAL,DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
+  INTEGER,SAVE :: tmp_ret_size = 0
+  INTEGER :: target_sig,pos,size_of_in,size_1,size_2,status=0,fileorig
+  INTEGER :: jl,jj,ji
+!---------------------------------------------------------------------
+!-
+! Compute the signature of the target
+!-
+  CALL gensig (target,target_sig)
+!-
+! Do we have this target in our database ?
+!-
+  CALL find_sig (nb_keys,keystr,target,keysig,target_sig,pos)
+!-
+  size_of_in = SIZE(ret_val)
+  size_1 = SIZE(ret_val,1)
+  size_2 = SIZE(ret_val,2)
+  IF (.NOT.ALLOCATED(tmp_ret_val)) THEN
+    ALLOCATE (tmp_ret_val(size_of_in))
+  ELSE IF (size_of_in > tmp_ret_size) THEN
+    DEALLOCATE (tmp_ret_val)
+    ALLOCATE (tmp_ret_val(size_of_in))
+    tmp_ret_size = size_of_in
+  ENDIF
+!-
+  jl=0
+  DO jj=1,size_2
+    DO ji=1,size_1
+      jl=jl+1
+      tmp_ret_val(jl) = ret_val(ji,jj)
+    ENDDO
+  ENDDO
+!-
+  IF (pos < 0) THEN
+!-- Get the information out of the file
+    CALL get_fil (target,status,fileorig,r_val=tmp_ret_val)
+!-- Put the data into the database
+    CALL get_wdb &
+ &   (target,target_sig,status,fileorig,size_of_in,r_val=tmp_ret_val)
+  ELSE
+!-- Get the value out of the database
+    CALL get_rdb (pos,size_of_in,target,r_val=tmp_ret_val)
   ENDIF
 !-
@@ -228,246 +382,63 @@
 END SUBROUTINE getinr2d
 !-
-!===
-!-
-SUBROUTINE getfilr (TARGET,status,fileorig,ret_val)
-!---------------------------------------------------------------------
-!- Subroutine that will extract from the file the values
-!- attributed to the keyword target
-!-
-!- REALS
-!- -----
-!-
-!- target   : in  : CHARACTER(LEN=*)  target for which we will
-!-                                    look in the file
-!- status   : out : INTEGER tells us from where we obtained the data
-!- fileorig : out : The index of the file from which the key comes
-!- ret_val  : out : REAL(nb_to_ret) values read
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  INTEGER :: status, fileorig
-  REAL,DIMENSION(:) :: ret_val
-!-
-  INTEGER :: nb_to_ret
-  INTEGER :: it, pos, len_str, epos, ppos, int_tmp, status_cnt
-  CHARACTER(LEN=3)  :: cnt, tl, dl
-  CHARACTER(LEN=10) :: fmt
-  CHARACTER(LEN=30) :: full_target
-  CHARACTER(LEN=80) :: str_READ, str_READ_lower, str_tmp
-  INTEGER :: full_target_sig
-  REAL :: compvalue
-!-
-  INTEGER,SAVE :: max_len = 0
-  LOGICAL,SAVE,ALLOCATABLE :: found(:)
-  LOGICAL,SAVE :: def_beha
-  LOGICAL :: compressed = .FALSE.
-!---------------------------------------------------------------------
-  nb_to_ret = SIZE(ret_val)
-  CALL getin_read
-!-
-! Get the variables and memory we need
-!-
-  IF (max_len == 0) THEN
-    ALLOCATE(found(nb_to_ret))
-    max_len = nb_to_ret
-  ENDIF
-  IF (max_len < nb_to_ret) THEN
-    DEALLOCATE(found)
-    ALLOCATE(found(nb_to_ret))
-    max_len = nb_to_ret
-  ENDIF
-  found(:) = .FALSE.
-!-
-! See what we find in the files read
-!-
-  DO it=1,nb_to_ret
-!---
-!-
-!-- First try the target as it is
-!---
-    full_target = TARGET(1:len_TRIM(target))
-    CALL gensig (full_target,full_target_sig)
-    CALL find_sig (nb_lines,targetlist,full_target, &
- &                 targetsiglist,full_target_sig,pos)
-!---
-!-- Another try
-!---
-    IF (pos < 0) THEN
-      WRITE(cnt,'(I3.3)') it
-      full_target = TARGET(1:len_TRIM(target))//'__'//cnt
-      CALL gensig (full_target,full_target_sig)
-      CALL find_sig (nb_lines,targetlist,full_target, &
- &                   targetsiglist,full_target_sig,pos)
-    ENDIF
-!---
-!-- A priori we dont know from which file the target could come.
-!-- Thus by default we attribute it to the first file :
-!---
-    fileorig = 1
-!--
-    IF (pos > 0) THEN
-!----
-      found(it) = .TRUE.
-      fileorig = fromfile(pos)
-!-----
-!---- DECODE
-!-----
-      str_READ = TRIM(ADJUSTL(fichier(pos)))
-      str_READ_lower = str_READ
-      CALL strlowercase (str_READ_lower)
-!----
-      IF (    (     (INDEX(str_READ_lower,'def') == 1)     &
- &             .AND.(LEN_TRIM(str_READ_lower) == 3)   )    &
- &        .OR.(     (INDEX(str_READ_lower,'default') == 1) &
- &             .AND.(LEN_TRIM(str_READ_lower) == 7)   )   ) THEN
-        def_beha = .TRUE.
-      ELSE
-        def_beha = .FALSE.
-        len_str = LEN_TRIM(str_READ)
-        epos = INDEX(str_READ,'e')
-        ppos = INDEX(str_READ,'.')
-!------
-        IF (epos > 0) THEN
-          WRITE(tl,'(I3.3)') len_str
-          WRITE(dl,'(I3.3)') epos-ppos-1
-          fmt='(e'//tl//'.'//dl//')'
-          READ(str_READ,fmt) ret_val(it)
-        ELSE IF (ppos > 0) THEN
-          WRITE(tl,'(I3.3)') len_str
-          WRITE(dl,'(I3.3)') len_str-ppos
-          fmt='(f'//tl//'.'//dl//')'
-          READ(str_READ,fmt) ret_val(it)
-        ELSE
-          WRITE(tl,'(I3.3)') len_str
-          fmt = '(I'//tl//')'
-          READ(str_READ,fmt) int_tmp
-          ret_val(it) = REAL(int_tmp)
-        ENDIF
-      ENDIF
-!----
-      targetsiglist(pos) = -1
-!-----
-!---- Is this the value of a compressed field ?
-!-----
-      IF (compline(pos) > 0) THEN
-        IF (compline(pos) == nb_to_ret) THEN
-          compressed = .TRUE.
-          compvalue = ret_val(it)
-        ELSE
-          WRITE(*,*) 'WARNING from getfilr'
-          WRITE(*,*) 'For key ',TRIM(TARGET), &
- & ' we have a compressed field but which does not have the right size.'
-          WRITE(*,*) 'We will try to fix that '
-          compressed = .TRUE.
-          compvalue = ret_val(it)
-        ENDIF
-      ENDIF
-    ELSE
-      found(it) = .FALSE.
-    ENDIF
-  ENDDO
-!--
-! If this is a compressed field then we will uncompress it
-!--
-  IF (compressed) THEN
-    DO it=1,nb_to_ret
-      IF (.NOT. found(it)) THEN
-        ret_val(it) = compvalue
-        found(it) = .TRUE.
-      ENDIF
-    ENDDO
-  ENDIF
-!-
-! Now we get the status for what we found
-!-
-  IF (def_beha) THEN
-    status = 2
-    WRITE(*,*) 'USING DEFAULT BEHAVIOUR FOR ',TRIM(TARGET)
+!=== CHARACTER INTERFACE
+!-
+SUBROUTINE getincs (target,ret_val)
+!---------------------------------------------------------------------
+!- Get a CHARACTER scalar. We first check if we find it
+!- in the database and if not we get it from the run.def
+!-
+!- getinc1d and getinc2d are written on the same pattern
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: target
+  CHARACTER(LEN=*) :: ret_val
+!-
+  CHARACTER(LEN=100),DIMENSION(1) :: tmp_ret_val
+  INTEGER :: target_sig,pos,status=0,fileorig
+!---------------------------------------------------------------------
+!-
+! Compute the signature of the target
+!-
+  CALL gensig (target,target_sig)
+!-
+! Do we have this target in our database ?
+!-
+  CALL find_sig (nb_keys,keystr,target,keysig,target_sig,pos)
+!-
+  tmp_ret_val(1) = ret_val
+!-
+  IF (pos < 0) THEN
+!-- Get the information out of the file
+    CALL get_fil (target,status,fileorig,c_val=tmp_ret_val)
+!-- Put the data into the database
+    CALL get_wdb &
+ &   (target,target_sig,status,fileorig,1,c_val=tmp_ret_val)
   ELSE
-    status_cnt = 0
-    DO it=1,nb_to_ret
-      IF (.NOT. found(it)) THEN
-        status_cnt = status_cnt+1
-        IF (nb_to_ret > 1) THEN
-          WRITE(str_tmp,'(a,"__",I3.3)') TRIM(TARGET),it
-        ELSE
-          str_tmp = TRIM(TARGET)
-        ENDIF
-        WRITE(*,*) 'USING DEFAULTS : ',TRIM(str_tmp),'=',ret_val(it)
-      ENDIF
-    ENDDO
-!---
-    IF (status_cnt == 0) THEN
-      status = 1
-    ELSE IF (status_cnt == nb_to_ret) THEN
-      status = 2
-    ELSE
-      status = 3
-    ENDIF
-  ENDIF
-!---------------------
-END SUBROUTINE getfilr
-!-
-!=== INTEGER INTERFACES
-!-
-SUBROUTINE getinis (TARGET,ret_val)
-!---------------------------------------------------------------------
-!- Get a interer scalar. We first check if we find it
-!- in the database and if not we get it from the run.def
-!-
-!- getini1d and getini2d are written on the same pattern
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  INTEGER :: ret_val
-!-
-  INTEGER,DIMENSION(1) :: tmp_ret_val
-  INTEGER :: target_sig, pos, status=0, fileorig
-!---------------------------------------------------------------------
-!-
-! Compute the signature of the target
-!-
-  CALL gensig (TARGET,target_sig)
-!-
-! Do we have this target in our database ?
-!-
-  CALL find_sig (nb_keys,keystr,target,keysig,target_sig,pos)
-!-
-  tmp_ret_val(1) = ret_val
-!-
-  IF (pos < 0) THEN
-!-- Ge the information out of the file
-    CALL getfili (TARGET,status,fileorig,tmp_ret_val)
-!-- Put the data into the database
-    CALL getdbwi (TARGET,target_sig,status,fileorig,1,tmp_ret_val)
-    ELSE
 !-- Get the value out of the database
-    CALL getdbri (pos,1,TARGET,tmp_ret_val)
+    CALL get_rdb (pos,1,target,c_val=tmp_ret_val)
   ENDIF
   ret_val = tmp_ret_val(1)
 !---------------------
-END SUBROUTINE getinis
-!-
+END SUBROUTINE getincs
 !===
-!-
-SUBROUTINE getini1d (TARGET,ret_val)
-!---------------------------------------------------------------------
-!- See getinis for details. It is the same thing but for a vector
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  INTEGER,DIMENSION(:) :: ret_val
-!-
-  INTEGER,DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
+SUBROUTINE getinc1d (target,ret_val)
+!---------------------------------------------------------------------
+!- See getincs for details. It is the same thing but for a vector
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: target
+  CHARACTER(LEN=*),DIMENSION(:) :: ret_val
+!-
+  CHARACTER(LEN=100),DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
   INTEGER,SAVE :: tmp_ret_size = 0
-  INTEGER :: target_sig, pos, size_of_in, status=0, fileorig
+  INTEGER :: target_sig,pos,size_of_in,status=0,fileorig
 !---------------------------------------------------------------------
 !-
 ! Compute the signature of the target
 !-
-  CALL gensig (TARGET,target_sig)
+  CALL gensig (target,target_sig)
 !-
 ! Do we have this target in our database ?
@@ -486,37 +457,35 @@
 !-
   IF (pos < 0) THEN
-!-- Ge the information out of the file
-    CALL getfili (TARGET,status,fileorig,tmp_ret_val)
+!-- Get the information out of the file
+    CALL get_fil (target,status,fileorig,c_val=tmp_ret_val)
 !-- Put the data into the database
-    CALL getdbwi &
- &   (TARGET,target_sig,status,fileorig,size_of_in,tmp_ret_val)
+    CALL get_wdb &
+ &   (target,target_sig,status,fileorig,size_of_in,c_val=tmp_ret_val)
   ELSE
 !-- Get the value out of the database
-    CALL getdbri (pos,size_of_in,TARGET,tmp_ret_val)
+    CALL get_rdb (pos,size_of_in,target,c_val=tmp_ret_val)
   ENDIF
   ret_val(1:size_of_in) = tmp_ret_val(1:size_of_in)
 !----------------------
-END SUBROUTINE getini1d
-!-
+END SUBROUTINE getinc1d
 !===
-!-
-SUBROUTINE getini2d (TARGET,ret_val)
-!---------------------------------------------------------------------
-!- See getinis for details. It is the same thing but for a matrix
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  INTEGER,DIMENSION(:,:) :: ret_val
-!-
-  INTEGER,DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
+SUBROUTINE getinc2d (target,ret_val)
+!---------------------------------------------------------------------
+!- See getincs for details. It is the same thing but for a matrix
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: target
+  CHARACTER(LEN=*),DIMENSION(:,:) :: ret_val
+!-
+  CHARACTER(LEN=100),DIMENSION(:),ALLOCATABLE,SAVE :: tmp_ret_val
   INTEGER,SAVE :: tmp_ret_size = 0
   INTEGER :: target_sig,pos,size_of_in,size_1,size_2,status=0,fileorig
-  INTEGER :: jl, jj, ji
+  INTEGER :: jl,jj,ji
 !---------------------------------------------------------------------
 !-
 ! Compute the signature of the target
 !-
-  CALL gensig (TARGET,target_sig)
+  CALL gensig (target,target_sig)
 !-
 ! Do we have this target in our database ?
@@ -544,12 +513,12 @@
 !-
   IF (pos < 0) THEN
-!-- Ge the information out of the file
-    CALL getfili (TARGET,status,fileorig,tmp_ret_val)
+!-- Get the information out of the file
+    CALL get_fil (target,status,fileorig,c_val=tmp_ret_val)
 !-- Put the data into the database
-    CALL getdbwi &
- &   (TARGET,target_sig,status,fileorig,size_of_in,tmp_ret_val)
+    CALL get_wdb &
+ &   (target,target_sig,status,fileorig,size_of_in,c_val=tmp_ret_val)
   ELSE
 !-- Get the value out of the database
-    CALL getdbri (pos,size_of_in,TARGET,tmp_ret_val)
+    CALL get_rdb (pos,size_of_in,target,c_val=tmp_ret_val)
   ENDIF
 !-
@@ -562,192 +531,27 @@
   ENDDO
 !----------------------
-END SUBROUTINE getini2d
-!-
-!===
-!-
-SUBROUTINE getfili (TARGET,status,fileorig,ret_val)
-!---------------------------------------------------------------------
-!- Subroutine that will extract from the file the values
-!- attributed to the keyword target
-!-
-!- INTEGER
-!- -------
-!-
-!- target   : in  : CHARACTER(LEN=*)  target for which we will
-!-                                    look in the file
-!- status   : out : INTEGER tells us from where we obtained the data
-!- fileorig : out : The index of the file from which the key comes
-!- ret_val  : out : INTEGER(nb_to_ret) values read
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  INTEGER :: status, fileorig
-  INTEGER :: ret_val(:)
-!-
-  INTEGER :: nb_to_ret
-  INTEGER :: it, pos, len_str, status_cnt
-  CHARACTER(LEN=3)  :: cnt, chlen
-  CHARACTER(LEN=10) ::  fmt
-  CHARACTER(LEN=30) :: full_target
-  CHARACTER(LEN=80) :: str_READ, str_READ_lower, str_tmp
-  INTEGER :: full_target_sig
-  INTEGER :: compvalue
-!-
-  INTEGER,SAVE :: max_len = 0
-  LOGICAL,SAVE,ALLOCATABLE :: found(:)
-  LOGICAL,SAVE :: def_beha
-  LOGICAL :: compressed = .FALSE.
-!---------------------------------------------------------------------
-  nb_to_ret = SIZE(ret_val)
-  CALL getin_read
-!-
-! Get the variables and memory we need
-!-
-  IF (max_len == 0) THEN
-    ALLOCATE(found(nb_to_ret))
-    max_len = nb_to_ret
-  ENDIF
-  IF (max_len < nb_to_ret) THEN
-    DEALLOCATE(found)
-    ALLOCATE(found(nb_to_ret))
-    max_len = nb_to_ret
-  ENDIF
-  found(:) = .FALSE.
-!-
-! See what we find in the files read
-!-
-  DO it=1,nb_to_ret
-!---
-!-- First try the target as it is
-!---
-    full_target = TARGET(1:len_TRIM(target))
-    CALL gensig (full_target,full_target_sig)
-    CALL find_sig (nb_lines,targetlist,full_target, &
- &                 targetsiglist,full_target_sig,pos)
-!---
-!-- Another try
-!---
-    IF (pos < 0) THEN
-      WRITE(cnt,'(I3.3)') it
-      full_target = TARGET(1:len_TRIM(target))//'__'//cnt
-      CALL gensig (full_target,full_target_sig)
-      CALL find_sig (nb_lines,targetlist,full_target, &
- &                   targetsiglist,full_target_sig,pos)
-    ENDIF
-!---
-!-- A priori we dont know from which file the target could come.
-!-- Thus by default we attribute it to the first file :
-!---
-    fileorig = 1
-!-
-    IF (pos > 0) THEN
-!-----
-      found(it) = .TRUE.
-      fileorig = fromfile(pos)
-!-----
-!---- DECODE
-!----
-      str_READ = TRIM(ADJUSTL(fichier(pos)))
-      str_READ_lower = str_READ
-      CALL strlowercase (str_READ_lower)
-!-----
-      IF (    (     (INDEX(str_READ_lower,'def') == 1)     &
- &             .AND.(LEN_TRIM(str_READ_lower) == 3)   )    &
- &        .OR.(     (INDEX(str_READ_lower,'default') == 1) &
- &             .AND.(LEN_TRIM(str_READ_lower) == 7)   )   ) THEN
-        def_beha = .TRUE.
-      ELSE
-        def_beha = .FALSE.
-        len_str = LEN_TRIM(str_READ)
-        WRITE(chlen,'(I3.3)') len_str
-        fmt = '(I'//chlen//')'
-        READ(str_READ,fmt) ret_val(it)
-      ENDIF
-!-----
-      targetsiglist(pos) = -1
-!-----
-!---- Is this the value of a compressed field ?
-!-----
-      IF (compline(pos) > 0) THEN
-        IF (compline(pos) == nb_to_ret) THEN
-          compressed = .TRUE.
-          compvalue = ret_val(it)
-        ELSE
-          WRITE(*,*) 'WARNING from getfilr'
-          WRITE(*,*) 'For key ',TRIM(TARGET), &
- & ' we have a compressed field but which does not have the right size.'
-          WRITE(*,*) 'We will try to fix that '
-          compressed = .TRUE.
-          compvalue = ret_val(it)
-        ENDIF
-      ENDIF
-    ELSE
-      found(it) = .FALSE.
-    ENDIF
-  ENDDO
-!-
-! If this is a compressed field then we will uncompress it
-!-
-  IF (compressed) THEN
-    DO it=1,nb_to_ret
-      IF (.NOT. found(it)) THEN
-        ret_val(it) = compvalue
-        found(it) = .TRUE.
-      ENDIF
-    ENDDO
-  ENDIF
-!-
-! Now we get the status for what we found
-!-
-  IF (def_beha) THEN
-    status = 2
-    WRITE(*,*) 'USING DEFAULT BEHAVIOUR FOR ',TRIM(TARGET)
-  ELSE
-    status_cnt = 0
-    DO it=1,nb_to_ret
-      IF (.NOT. found(it)) THEN
-        status_cnt = status_cnt+1
-        IF (nb_to_ret > 1) THEN
-          WRITE(str_tmp,'(a,"__",I3.3)') TRIM(TARGET),it
-        ELSE
-          str_tmp = TRIM(TARGET)
-        ENDIF
-        WRITE(*,*) 'USING DEFAULTS : ',TRIM(str_tmp),'=',ret_val(it)
-      ENDIF
-    ENDDO
-!---
-    IF (status_cnt == 0) THEN
-      status = 1
-    ELSE IF (status_cnt == nb_to_ret) THEN
-      status = 2
-    ELSE
-      status = 3
-    ENDIF
-  ENDIF
-!---------------------
-END SUBROUTINE getfili
-!-
-!=== CHARACTER INTERFACES
-!-
-SUBROUTINE getincs (TARGET,ret_val)
-!---------------------------------------------------------------------
-!- Get a CHARACTER scalar. We first check if we find it
+END SUBROUTINE getinc2d
+!-
+!=== LOGICAL INTERFACE
+!-
+SUBROUTINE getinls (target,ret_val)
+!---------------------------------------------------------------------
+!- Get a logical scalar. We first check if we find it
 !- in the database and if not we get it from the run.def
 !-
-!- getinc1d and getinc2d are written on the same pattern
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: TARGET
-  CHARACTER(LEN=*) :: ret_val
-!-
-  CHARACTER(LEN=100),DIMENSION(1) :: tmp_ret_val
-  INTEGER :: target_sig, pos, status=0, fileorig
+!- getinl1d and getinl2d are written on the same pattern
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: target
+  LOGICAL :: ret_val
+!-
+  LOGICAL,DIMENSION(1) :: tmp_ret_val
+  INTEGER :: target_sig,pos,status=0,fileorig
 !---------------------------------------------------------------------
 !-
 ! Compute the signature of the target
 !-
-  CALL gensig (TARGET,target_sig)
+  CALL gensig (target,target_sig)
 !-
 ! Do we have this target in our database ?
